commit d04583df6e2ae2cffb7f5df79081bbbc539b7af9
Author: Andrea Corallo <andrea.corallo@arm.com>
Date:   Tue Feb 28 11:03:18 2023

    arm: Mve testsuite improvements
    
    Hello all,
    
    this patch improves a number of MVE tests in the testsuite for more
    precise and better coverage using check-function-bodies instead of
    scan-assembler checks.  Also all intrusctions prescribed in the ACLE[1]
    are now checked.
    
    Best Regards
    
      Andrea
    
    [1] <https://github.com/ARM-software/acle>
    
    gcc/testsuite/ChangeLog:
    
            * gcc.target/arm/mve/intrinsics/vld1q_f16.c: Use
            check-function-bodies instead of scan-assembler checks.  Use
            extern "C" for C++ testing.
            * gcc.target/arm/mve/intrinsics/vld1q_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vld1q_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vld1q_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vld1q_s8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vld1q_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vld1q_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vld1q_u8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vld1q_z_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vld1q_z_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vld1q_z_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vld1q_z_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vld1q_z_s8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vld1q_z_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vld1q_z_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vld1q_z_u8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vld4q_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vld4q_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vld4q_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vld4q_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vld4q_s8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vld4q_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vld4q_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vld4q_u8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrbq_gather_offset_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrbq_gather_offset_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrbq_gather_offset_s8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrbq_gather_offset_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrbq_gather_offset_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrbq_gather_offset_u8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrbq_gather_offset_z_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrbq_gather_offset_z_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrbq_gather_offset_z_s8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrbq_gather_offset_z_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrbq_gather_offset_z_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrbq_gather_offset_z_u8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrbq_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrbq_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrbq_s8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrbq_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrbq_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrbq_u8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrbq_z_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrbq_z_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrbq_z_s8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrbq_z_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrbq_z_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrbq_z_u8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrdq_gather_base_s64.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrdq_gather_base_u64.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrdq_gather_base_wb_s64.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrdq_gather_base_wb_u64.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrdq_gather_base_wb_z_s64.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrdq_gather_base_wb_z_u64.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrdq_gather_base_z_s64.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrdq_gather_base_z_u64.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrdq_gather_offset_s64.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrdq_gather_offset_u64.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrdq_gather_offset_z_s64.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrdq_gather_offset_z_u64.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrdq_gather_shifted_offset_s64.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrdq_gather_shifted_offset_u64.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrdq_gather_shifted_offset_z_s64.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrdq_gather_shifted_offset_z_u64.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrhq_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrhq_gather_offset_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrhq_gather_offset_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrhq_gather_offset_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrhq_gather_offset_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrhq_gather_offset_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrhq_gather_offset_z_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrhq_gather_offset_z_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrhq_gather_offset_z_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrhq_gather_offset_z_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrhq_gather_offset_z_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrhq_gather_shifted_offset_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrhq_gather_shifted_offset_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrhq_gather_shifted_offset_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrhq_gather_shifted_offset_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrhq_gather_shifted_offset_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrhq_gather_shifted_offset_z_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrhq_gather_shifted_offset_z_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrhq_gather_shifted_offset_z_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrhq_gather_shifted_offset_z_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrhq_gather_shifted_offset_z_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrhq_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrhq_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrhq_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrhq_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrhq_z_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrhq_z_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrhq_z_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrhq_z_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrhq_z_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrwq_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrwq_gather_base_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrwq_gather_base_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrwq_gather_base_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrwq_gather_base_wb_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrwq_gather_base_wb_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrwq_gather_base_wb_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrwq_gather_base_wb_z_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrwq_gather_base_wb_z_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrwq_gather_base_wb_z_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrwq_gather_base_z_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrwq_gather_base_z_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrwq_gather_base_z_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrwq_gather_offset_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrwq_gather_offset_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrwq_gather_offset_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrwq_gather_offset_z_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrwq_gather_offset_z_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrwq_gather_offset_z_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrwq_gather_shifted_offset_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrwq_gather_shifted_offset_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrwq_gather_shifted_offset_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrwq_gather_shifted_offset_z_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrwq_gather_shifted_offset_z_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrwq_gather_shifted_offset_z_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrwq_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrwq_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrwq_z_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrwq_z_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vldrwq_z_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vst2q_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vst2q_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vst2q_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vst2q_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vst2q_s8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vst2q_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vst2q_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vst2q_u8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vst4q_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vst4q_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vst4q_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vst4q_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vst4q_s8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vst4q_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vst4q_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vst4q_u8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrbq_p_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrbq_p_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrbq_p_s8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrbq_p_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrbq_p_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrbq_p_u8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrbq_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrbq_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrbq_s8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrbq_scatter_offset_p_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrbq_scatter_offset_p_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrbq_scatter_offset_p_s8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrbq_scatter_offset_p_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrbq_scatter_offset_p_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrbq_scatter_offset_p_u8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrbq_scatter_offset_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrbq_scatter_offset_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrbq_scatter_offset_s8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrbq_scatter_offset_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrbq_scatter_offset_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrbq_scatter_offset_u8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrbq_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrbq_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrbq_u8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrhq_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrhq_p_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrhq_p_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrhq_p_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrhq_p_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrhq_p_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrhq_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrhq_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrhq_scatter_offset_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrhq_scatter_offset_p_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrhq_scatter_offset_p_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrhq_scatter_offset_p_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrhq_scatter_offset_p_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrhq_scatter_offset_p_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrhq_scatter_offset_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrhq_scatter_offset_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrhq_scatter_offset_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrhq_scatter_offset_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrhq_scatter_shifted_offset_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrhq_scatter_shifted_offset_p_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrhq_scatter_shifted_offset_p_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrhq_scatter_shifted_offset_p_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrhq_scatter_shifted_offset_p_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrhq_scatter_shifted_offset_p_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrhq_scatter_shifted_offset_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrhq_scatter_shifted_offset_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrhq_scatter_shifted_offset_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrhq_scatter_shifted_offset_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrhq_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vstrhq_u32.c: Likewise.

diff --git a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_f16.c b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_f16.c
index 699e40d0e3b..f0a9243a6d5 100644
--- a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_f16.c
+++ b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_f16.c
@@ -1,20 +1,41 @@
 /* { dg-require-effective-target arm_v8_1m_mve_fp_ok } */
 /* { dg-add-options arm_v8_1m_mve_fp } */
 /* { dg-additional-options "-O2" } */
+/* { dg-final { check-function-bodies "**" "" } } */
 
 #include "arm_mve.h"
 
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+/*
+**foo:
+**	...
+**	vldrh.16	q[0-9]+, \[(?:ip|fp|r[0-9]+)\](?:	@.*|)
+**	...
+*/
 float16x8_t
-foo (float16_t const * base)
+foo (float16_t const *base)
 {
   return vld1q_f16 (base);
 }
 
+
+/*
+**foo1:
+**	...
+**	vldrh.16	q[0-9]+, \[(?:ip|fp|r[0-9]+)\](?:	@.*|)
+**	...
+*/
 float16x8_t
-foo1 (float16_t const * base)
+foo1 (float16_t const *base)
 {
   return vld1q (base);
 }
 
-/* { dg-final { scan-assembler-times "vldrh.16" 2 }  } */
-/* { dg-final { scan-assembler-not "__ARM_undef" } } */
+#ifdef __cplusplus
+}
+#endif
+
+/* { dg-final { scan-assembler-not "__ARM_undef" } } */
\ No newline at end of file
diff --git a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_f32.c b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_f32.c
index 86592303362..129d256dd86 100644
--- a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_f32.c
+++ b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_f32.c
@@ -1,20 +1,41 @@
 /* { dg-require-effective-target arm_v8_1m_mve_fp_ok } */
 /* { dg-add-options arm_v8_1m_mve_fp } */
 /* { dg-additional-options "-O2" } */
+/* { dg-final { check-function-bodies "**" "" } } */
 
 #include "arm_mve.h"
 
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+/*
+**foo:
+**	...
+**	vldrw.32	q[0-9]+, \[(?:ip|fp|r[0-9]+)\](?:	@.*|)
+**	...
+*/
 float32x4_t
-foo (float32_t const * base)
+foo (float32_t const *base)
 {
   return vld1q_f32 (base);
 }
 
+
+/*
+**foo1:
+**	...
+**	vldrw.32	q[0-9]+, \[(?:ip|fp|r[0-9]+)\](?:	@.*|)
+**	...
+*/
 float32x4_t
-foo1 (float32_t const * base)
+foo1 (float32_t const *base)
 {
   return vld1q (base);
 }
 
-/* { dg-final { scan-assembler-times "vldrw.32" 2 }  } */
-/* { dg-final { scan-assembler-not "__ARM_undef" } } */
+#ifdef __cplusplus
+}
+#endif
+
+/* { dg-final { scan-assembler-not "__ARM_undef" } } */
\ No newline at end of file
diff --git a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_s16.c b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_s16.c
index f4f04f534db..a95bf6c4260 100644
--- a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_s16.c
+++ b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_s16.c
@@ -1,20 +1,41 @@
 /* { dg-require-effective-target arm_v8_1m_mve_ok } */
 /* { dg-add-options arm_v8_1m_mve } */
 /* { dg-additional-options "-O2" } */
+/* { dg-final { check-function-bodies "**" "" } } */
 
 #include "arm_mve.h"
 
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+/*
+**foo:
+**	...
+**	vldrh.16	q[0-9]+, \[(?:ip|fp|r[0-9]+)\](?:	@.*|)
+**	...
+*/
 int16x8_t
-foo (int16_t const * base)
+foo (int16_t const *base)
 {
   return vld1q_s16 (base);
 }
 
+
+/*
+**foo1:
+**	...
+**	vldrh.16	q[0-9]+, \[(?:ip|fp|r[0-9]+)\](?:	@.*|)
+**	...
+*/
 int16x8_t
-foo1 (int16_t const * base)
+foo1 (int16_t const *base)
 {
   return vld1q (base);
 }
 
-/* { dg-final { scan-assembler-times "vldrh.16" 2 }  } */
-/* { dg-final { scan-assembler-not "__ARM_undef" } } */
+#ifdef __cplusplus
+}
+#endif
+
+/* { dg-final { scan-assembler-not "__ARM_undef" } } */
\ No newline at end of file
diff --git a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_s32.c b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_s32.c
index e0f66166751..bb24e52d164 100644
--- a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_s32.c
+++ b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_s32.c
@@ -1,20 +1,41 @@
 /* { dg-require-effective-target arm_v8_1m_mve_ok } */
 /* { dg-add-options arm_v8_1m_mve } */
 /* { dg-additional-options "-O2" } */
+/* { dg-final { check-function-bodies "**" "" } } */
 
 #include "arm_mve.h"
 
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+/*
+**foo:
+**	...
+**	vldrw.32	q[0-9]+, \[(?:ip|fp|r[0-9]+)\](?:	@.*|)
+**	...
+*/
 int32x4_t
-foo (int32_t const * base)
+foo (int32_t const *base)
 {
   return vld1q_s32 (base);
 }
 
+
+/*
+**foo1:
+**	...
+**	vldrw.32	q[0-9]+, \[(?:ip|fp|r[0-9]+)\](?:	@.*|)
+**	...
+*/
 int32x4_t
-foo1 (int32_t const * base)
+foo1 (int32_t const *base)
 {
   return vld1q (base);
 }
 
-/* { dg-final { scan-assembler-times "vldrw.32" 2 }  } */
-/* { dg-final { scan-assembler-not "__ARM_undef" } } */
+#ifdef __cplusplus
+}
+#endif
+
+/* { dg-final { scan-assembler-not "__ARM_undef" } } */
\ No newline at end of file
diff --git a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_s8.c b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_s8.c
index 1b7edead6b1..0d89c2f19cd 100644
--- a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_s8.c
+++ b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_s8.c
@@ -1,20 +1,41 @@
 /* { dg-require-effective-target arm_v8_1m_mve_ok } */
 /* { dg-add-options arm_v8_1m_mve } */
 /* { dg-additional-options "-O2" } */
+/* { dg-final { check-function-bodies "**" "" } } */
 
 #include "arm_mve.h"
 
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+/*
+**foo:
+**	...
+**	vldrb.8	q[0-9]+, \[(?:ip|fp|r[0-9]+)\](?:	@.*|)
+**	...
+*/
 int8x16_t
-foo (int8_t const * base)
+foo (int8_t const *base)
 {
   return vld1q_s8 (base);
 }
 
+
+/*
+**foo1:
+**	...
+**	vldrb.8	q[0-9]+, \[(?:ip|fp|r[0-9]+)\](?:	@.*|)
+**	...
+*/
 int8x16_t
-foo1 (int8_t const * base)
+foo1 (int8_t const *base)
 {
   return vld1q (base);
 }
 
-/* { dg-final { scan-assembler-times "vldrb.8" 2 }  } */
-/* { dg-final { scan-assembler-not "__ARM_undef" } } */
+#ifdef __cplusplus
+}
+#endif
+
+/* { dg-final { scan-assembler-not "__ARM_undef" } } */
\ No newline at end of file
diff --git a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_u16.c b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_u16.c
index 50e1f5cedcb..a31baf75fed 100644
--- a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_u16.c
+++ b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_u16.c
@@ -1,20 +1,41 @@
 /* { dg-require-effective-target arm_v8_1m_mve_ok } */
 /* { dg-add-options arm_v8_1m_mve } */
 /* { dg-additional-options "-O2" } */
+/* { dg-final { check-function-bodies "**" "" } } */
 
 #include "arm_mve.h"
 
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+/*
+**foo:
+**	...
+**	vldrh.16	q[0-9]+, \[(?:ip|fp|r[0-9]+)\](?:	@.*|)
+**	...
+*/
 uint16x8_t
-foo (uint16_t const * base)
+foo (uint16_t const *base)
 {
   return vld1q_u16 (base);
 }
 
+
+/*
+**foo1:
+**	...
+**	vldrh.16	q[0-9]+, \[(?:ip|fp|r[0-9]+)\](?:	@.*|)
+**	...
+*/
 uint16x8_t
-foo1 (uint16_t const * base)
+foo1 (uint16_t const *base)
 {
   return vld1q (base);
 }
 
-/* { dg-final { scan-assembler-times "vldrh.16" 2 }  } */
-/* { dg-final { scan-assembler-not "__ARM_undef" } } */
+#ifdef __cplusplus
+}
+#endif
+
+/* { dg-final { scan-assembler-not "__ARM_undef" } } */
\ No newline at end of file
diff --git a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_u32.c b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_u32.c
index a13fe824382..7d4f858c784 100644
--- a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_u32.c
+++ b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_u32.c
@@ -1,20 +1,41 @@
 /* { dg-require-effective-target arm_v8_1m_mve_ok } */
 /* { dg-add-options arm_v8_1m_mve } */
 /* { dg-additional-options "-O2" } */
+/* { dg-final { check-function-bodies "**" "" } } */
 
 #include "arm_mve.h"
 
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+/*
+**foo:
+**	...
+**	vldrw.32	q[0-9]+, \[(?:ip|fp|r[0-9]+)\](?:	@.*|)
+**	...
+*/
 uint32x4_t
-foo (uint32_t const * base)
+foo (uint32_t const *base)
 {
   return vld1q_u32 (base);
 }
 
+
+/*
+**foo1:
+**	...
+**	vldrw.32	q[0-9]+, \[(?:ip|fp|r[0-9]+)\](?:	@.*|)
+**	...
+*/
 uint32x4_t
-foo1 (uint32_t const * base)
+foo1 (uint32_t const *base)
 {
   return vld1q (base);
 }
 
-/* { dg-final { scan-assembler-times "vldrw.32" 2 }  } */
-/* { dg-final { scan-assembler-not "__ARM_undef" } } */
+#ifdef __cplusplus
+}
+#endif
+
+/* { dg-final { scan-assembler-not "__ARM_undef" } } */
\ No newline at end of file
diff --git a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_u8.c b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_u8.c
index dfd1deb93f0..455ec5ce105 100644
--- a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_u8.c
+++ b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_u8.c
@@ -1,20 +1,41 @@
 /* { dg-require-effective-target arm_v8_1m_mve_ok } */
 /* { dg-add-options arm_v8_1m_mve } */
 /* { dg-additional-options "-O2" } */
+/* { dg-final { check-function-bodies "**" "" } } */
 
 #include "arm_mve.h"
 
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+/*
+**foo:
+**	...
+**	vldrb.8	q[0-9]+, \[(?:ip|fp|r[0-9]+)\](?:	@.*|)
+**	...
+*/
 uint8x16_t
-foo (uint8_t const * base)
+foo (uint8_t const *base)
 {
   return vld1q_u8 (base);
 }
 
+
+/*
+**foo1:
+**	...
+**	vldrb.8	q[0-9]+, \[(?:ip|fp|r[0-9]+)\](?:	@.*|)
+**	...
+*/
 uint8x16_t
-foo1 (uint8_t const * base)
+foo1 (uint8_t const *base)
 {
   return vld1q (base);
 }
 
-/* { dg-final { scan-assembler-times "vldrb.8" 2 }  } */
-/* { dg-final { scan-assembler-not "__ARM_undef" } } */
+#ifdef __cplusplus
+}
+#endif
+
+/* { dg-final { scan-assembler-not "__ARM_undef" } } */
\ No newline at end of file
diff --git a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_z_f16.c b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_z_f16.c
index 3c32e408e42..951b795fd59 100644
--- a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_z_f16.c
+++ b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_z_f16.c
@@ -1,21 +1,49 @@
 /* { dg-require-effective-target arm_v8_1m_mve_fp_ok } */
 /* { dg-add-options arm_v8_1m_mve_fp } */
 /* { dg-additional-options "-O2" } */
+/* { dg-final { check-function-bodies "**" "" } } */
 
 #include "arm_mve.h"
 
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+/*
+**foo:
+**	...
+**	vmsr	p0, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vpst(?:	@.*|)
+**	...
+**	vldrht.16	q[0-9]+, \[(?:ip|fp|r[0-9]+)\](?:	@.*|)
+**	...
+*/
 float16x8_t
-foo (float16_t const * base, mve_pred16_t p)
+foo (float16_t const *base, mve_pred16_t p)
 {
   return vld1q_z_f16 (base, p);
 }
 
+
+/*
+**foo1:
+**	...
+**	vmsr	p0, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vpst(?:	@.*|)
+**	...
+**	vldrht.16	q[0-9]+, \[(?:ip|fp|r[0-9]+)\](?:	@.*|)
+**	...
+*/
 float16x8_t
-foo1 (float16_t const * base, mve_pred16_t p)
+foo1 (float16_t const *base, mve_pred16_t p)
 {
   return vld1q_z (base, p);
 }
 
-/* { dg-final { scan-assembler-times "vpst" 2 }  } */
-/* { dg-final { scan-assembler-times "vldrht.16" 2 }  } */
-/* { dg-final { scan-assembler-not "__ARM_undef" } } */
+#ifdef __cplusplus
+}
+#endif
+
+/* { dg-final { scan-assembler-not "__ARM_undef" } } */
\ No newline at end of file
diff --git a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_z_f32.c b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_z_f32.c
index 3fc935c889b..4b43f0f4be3 100644
--- a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_z_f32.c
+++ b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_z_f32.c
@@ -1,21 +1,49 @@
 /* { dg-require-effective-target arm_v8_1m_mve_fp_ok } */
 /* { dg-add-options arm_v8_1m_mve_fp } */
 /* { dg-additional-options "-O2" } */
+/* { dg-final { check-function-bodies "**" "" } } */
 
 #include "arm_mve.h"
 
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+/*
+**foo:
+**	...
+**	vmsr	p0, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vpst(?:	@.*|)
+**	...
+**	vldrwt.32	q[0-9]+, \[(?:ip|fp|r[0-9]+)\](?:	@.*|)
+**	...
+*/
 float32x4_t
-foo (float32_t const * base, mve_pred16_t p)
+foo (float32_t const *base, mve_pred16_t p)
 {
   return vld1q_z_f32 (base, p);
 }
 
+
+/*
+**foo1:
+**	...
+**	vmsr	p0, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vpst(?:	@.*|)
+**	...
+**	vldrwt.32	q[0-9]+, \[(?:ip|fp|r[0-9]+)\](?:	@.*|)
+**	...
+*/
 float32x4_t
-foo1 (float32_t const * base, mve_pred16_t p)
+foo1 (float32_t const *base, mve_pred16_t p)
 {
   return vld1q_z (base, p);
 }
 
-/* { dg-final { scan-assembler-times "vpst" 2 }  } */
-/* { dg-final { scan-assembler-times "vldrwt.32" 2 }  } */
-/* { dg-final { scan-assembler-not "__ARM_undef" } } */
+#ifdef __cplusplus
+}
+#endif
+
+/* { dg-final { scan-assembler-not "__ARM_undef" } } */
\ No newline at end of file
diff --git a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_z_s16.c b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_z_s16.c
index 49cc81092f3..a65c10c5fc1 100644
--- a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_z_s16.c
+++ b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_z_s16.c
@@ -1,21 +1,49 @@
 /* { dg-require-effective-target arm_v8_1m_mve_ok } */
 /* { dg-add-options arm_v8_1m_mve } */
 /* { dg-additional-options "-O2" } */
+/* { dg-final { check-function-bodies "**" "" } } */
 
 #include "arm_mve.h"
 
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+/*
+**foo:
+**	...
+**	vmsr	p0, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vpst(?:	@.*|)
+**	...
+**	vldrht.16	q[0-9]+, \[(?:ip|fp|r[0-9]+)\](?:	@.*|)
+**	...
+*/
 int16x8_t
-foo (int16_t const * base, mve_pred16_t p)
+foo (int16_t const *base, mve_pred16_t p)
 {
   return vld1q_z_s16 (base, p);
 }
 
+
+/*
+**foo1:
+**	...
+**	vmsr	p0, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vpst(?:	@.*|)
+**	...
+**	vldrht.16	q[0-9]+, \[(?:ip|fp|r[0-9]+)\](?:	@.*|)
+**	...
+*/
 int16x8_t
-foo1 (int16_t const * base, mve_pred16_t p)
+foo1 (int16_t const *base, mve_pred16_t p)
 {
   return vld1q_z (base, p);
 }
 
-/* { dg-final { scan-assembler-times "vpst" 2 }  } */
-/* { dg-final { scan-assembler-times "vldrht.16" 2 }  } */
-/* { dg-final { scan-assembler-not "__ARM_undef" } } */
+#ifdef __cplusplus
+}
+#endif
+
+/* { dg-final { scan-assembler-not "__ARM_undef" } } */
\ No newline at end of file
diff --git a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_z_s32.c b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_z_s32.c
index ec317cd70e8..31749046fc6 100644
--- a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_z_s32.c
+++ b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vld1q_z_s32.c
@@ -1,21 +1,49 @@
 /* { dg-require-effective-target arm_v8_1m_mve_ok } */
 /* { dg-add-options arm_v8_1m_mve } */
 /* { dg-additional-options "-O2" } */
+/* { dg-final { check-function-bodies "**" "" } } */
 
 #include "arm_mve.h"
 
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+/*
+**foo:
+**	...
+**	vmsr	p0, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vpst(?:	@.*|)
+**	...
+**	vldrwt.32	q[0-9]+, \[(?:ip|fp|r[0-9]+)\](?:	@.*|)
+**	...
+*/
 int32x4_t
-foo (int32_t const * base, mve_pred16_t p)
+foo (int32_t const *base, mve_pred16_t p)
 {
   return vld1q_z_s32 (base, p);
 }
 
+
+/*
+**foo1:
+**	...
+**	vmsr	p0, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vpst(?:	@.*|)
+**	...
+**	vldrwt.32	q[0-9]+, \[(?:ip|fp|r[0-9]+)\](?:	@.*|)
+**	...
+*/
 int32x4_t
-foo1 (int32_t const * base, mve_pred16_t p)
+foo1 (int32_t const *base, mve_pred16_t p)
 {
   return vld1q_z (base, p);
 }
 
-/* { dg-final { scan-assembler-times "vpst" 2 }  } */
-/* { dg-final { scan-assembler-times "vldrwt.32" 2 }  } */
-/* { dg-final { scan-assembler-not "__ARM_undef" } } */
+#ifdef __cplusplus
+}
+#endif
+
+/* { dg-final { scan-assembler-not "__ARM_undef" } } */
\ No newline at end of file
